/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/


#include <QtCore/QDir>
#include <QtCore/QVariant>

#include <distributed_computing/LocalTaskManager.h>

#include "MachineInfoWriter.h"

namespace GB2 {

void MachineInfoWriter::sl_writeMachineInfoFile() {
    QDir tasksDirectory = QDir::homePath();
    QVariantMap machineInfoMap; // FIXME: move sftp constants to one place
    machineInfoMap.insert( "uuid", LocalTaskManager::getUuid().toString() );
    machineInfoMap.insert( "servicesList", LocalTaskManager::getServicesList() );
    machineInfoMap.insert( "hostname", LocalTaskManager::getHostName() );
    QVariantList resultList;
    resultList << RemoteTaskError( true, "" ).serialize();
    resultList << QVariant( machineInfoMap );
    
    QFile machineInfoFile( tasksDirectory.absoluteFilePath( "machineInfo" ) );
    machineInfoFile.open( QIODevice::WriteOnly );
    QDataStream stream( &machineInfoFile );
    stream << resultList;
    machineInfoFile.close();
}

} // GB2
