/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include "CircularViewSplitter.h"
#include "CircularView.h"
#include <QtGui/QVBoxLayout>

#include <core_api/GObject.h>
#include <gobjects/GObjectTypes.h>

namespace GB2 {

CircularViewSplitter::CircularViewSplitter( AnnotatedDNAView* view)
	: ADVSplitWidget(view)
{
	QVBoxLayout *layout = new QVBoxLayout;
	splitter = new QSplitter(Qt::Horizontal);
	layout->setSpacing(0);
	layout->setContentsMargins(0,0,3,0);
	layout->addWidget(splitter);
	setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Preferred);
	setBaseSize(600,600);
	setAcceptDrops(false);

	setLayout(layout);
}

void CircularViewSplitter::updateState( const QVariantMap&) {
	//TODO:
}

void CircularViewSplitter::saveState( QVariantMap& m ) {
	//TODO:
}

void CircularViewSplitter::addView(CircularView* view) {
	circularViewList.append(view);
	splitter->insertWidget(0, view);
	adaptSize();
}

void CircularViewSplitter::removeView(CircularView* view) {
	circularViewList.removeAll(view);
}

bool CircularViewSplitter::isEmpty() {
	return circularViewList.isEmpty();
}

void CircularViewSplitter::adaptSize()
{
	setMaximumHeight(1000);
	QWidget* widget = parentWidget();
	Q_ASSERT(widget != NULL);
	QSplitter* parentSplitter = qobject_cast<QSplitter* > (widget);
	
	int index = parentSplitter->indexOf(this);
	QList<int> sizes = parentSplitter->sizes();
	sizes[index] = 500;
	parentSplitter->setSizes(sizes);
 //   /*setMaximumHeight(1000);
 //   QWidget* widget = parentWidget();
 //   Q_ASSERT(widget != NULL);
	//QSplitter* parentSplitter = qobject_cast<QSplitter* > (widget);

	//int splitterHeight = 0;
	//int maxHeight = 0;
	//foreach(CircularView* v, circularViewList) {
	//	maxHeight = qMax(v->renderArea->height(), maxHeight);
	//}
	//maxHeight = qMin(parentSplitter->height(), maxHeight);
 //   
 //   int index = parentSplitter->indexOf(this);
 //   QList<int> sizes = parentSplitter->sizes();
 //   for(int i = 0; i < sizes.count(); ++i) {
	//	int sizeAt = sizes.at(i);
	//	if(sizeAt > maxHeight) {
	//		sizes[i] = sizeAt - maxHeight;
	//		splitterHeight += maxHeight;
	//		break;
	//	} else {
	//		int minWidgetHeight = qMax(parentSplitter->widget(i)->minimumHeight(), 200);
	//		if(minWidgetHeight < sizeAt) {
	//			sizes[i] = minWidgetHeight;
	//			splitterHeight += sizeAt - minWidgetHeight;
	//			maxHeight -= sizeAt - minWidgetHeight;
	//		}
	//	}
 //       
 //   }
 //   sizes[index] = splitterHeight;
 //   parentSplitter->setSizes(sizes);*/
}

} //namespace GB2