/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_CIRCULAR_VIEW_SPLITTER_H_
#define _GB2_CIRCULAR_VIEW_SPLITTER_H_

#include "CircularView.h"
#include <util_ov_annotated_dna/ADVSplitWidget.h>

namespace GB2 {

class CircularViewSplitter : public ADVSplitWidget{
	Q_OBJECT
public:
	CircularViewSplitter( AnnotatedDNAView* view);
	// there are no special object handling with this view
	// it only shows existing AO only
	virtual bool acceptsGObject(GObject* objects) {return false;} 
	virtual void updateState(const QVariantMap& m);
	virtual void saveState(QVariantMap& m);
	void addView(CircularView* view);
	void adaptSize();
	void removeView(CircularView* view);
	bool isEmpty();
private:
	QSplitter* splitter;
	QList<CircularView*> circularViewList;
};

} //namespace GB2

#endif //_GB2_CIRCULAR_VIEW_SPLITTER_H_