/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include "TaskLocalStorage.h"

extern "C" {
#include "kalign2/kalign2.h"
#include "kalign2/kalign2_context.h"
}

extern "C" kalign_context *getKalignContext() {
	return GB2::TaskLocalData::current();
}
//int getKalignWorkerID() {
//	return GB2::TaskLocalData::currentWorkerID();
//}

namespace GB2 {

QThreadStorage<kalign_contextTLSRef*> TaskLocalData::tls;

class kalign_context* TaskLocalData::current(){
	kalign_contextTLSRef* ref = tls.localData();
	if (ref!=NULL) {
		assert(ref->ctx!=NULL);
		return ref->ctx;
	}
	assert(0);
	return NULL;
}

void TaskLocalData::bindToKalignTLSContext(kalign_context *ctx, int workerID) {
	assert(ctx!=NULL);
	assert(!tls.hasLocalData());
	tls.setLocalData(new kalign_contextTLSRef(ctx, workerID));
}

void TaskLocalData::detachKalignTLSContext() {
	kalign_contextTLSRef* ref = tls.localData();
	assert(ref!=NULL && ref->ctx!=NULL);
	ref->ctx = NULL;
	tls.setLocalData(NULL);
}


}//namespace

