/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _KALIGN_TASK_LOCAL_STORAGE_
#define _KALIGN_TASK_LOCAL_STORAGE_

#include <QtCore/QThreadStorage>

struct kalign_context;

namespace GB2 {

class kalign_contextTLSRef {
public:
	kalign_contextTLSRef(kalign_context* _ctx, int _workerID) : ctx(_ctx), workerID(_workerID){}
	kalign_context* ctx;
	int workerID;
};

class TaskLocalData {
public:
	static kalign_context* current();

	//static unsigned currentWorkerID();

	static void bindToKalignTLSContext(kalign_context *ctx, int workerID = 0);

	static void detachKalignTLSContext();


private:
	static QThreadStorage<kalign_contextTLSRef*> tls;
};
} //namespace

#endif //_KALIGN_TASK_LOCAL_STORAGE_
